- [HTTP request](https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.connectionProfiles/discover#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.connectionProfiles/discover#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.connectionProfiles/discover#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.connectionProfiles/discover#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.connectionProfiles/discover#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.connectionProfiles/discover#body.DiscoverConnectionProfileResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.connectionProfiles/discover#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.connectionProfiles/discover#body.aspect_1)
- [Examples](https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.connectionProfiles/discover#examples)
- [Try it!](https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.connectionProfiles/discover#try-it)

Use this method to discover a connection profile. The discover API call exposes the data objects and metadata belonging to the profile. Typically, a request returns children data objects of a parent data object that's optionally supplied in the request.

### HTTP request

Choose a location:
<button value="global" default="">global</button> <button value="africa-south1">africa-south1</button> <button value="asia-east1">asia-east1</button> <button value="asia-east2">asia-east2</button> <button value="asia-northeast1">asia-northeast1</button> <button value="asia-northeast2">asia-northeast2</button> <button value="asia-northeast3">asia-northeast3</button> <button value="asia-south1">asia-south1</button> <button value="asia-south2">asia-south2</button> <button value="asia-southeast1">asia-southeast1</button> <button value="asia-southeast2">asia-southeast2</button> <button value="asia-southeast3">asia-southeast3</button> <button value="australia-southeast1">australia-southeast1</button> <button value="australia-southeast2">australia-southeast2</button> <button value="europe-central2">europe-central2</button> <button value="europe-north1">europe-north1</button> <button value="europe-north2">europe-north2</button> <button value="europe-southwest1">europe-southwest1</button> <button value="europe-west1">europe-west1</button> <button value="europe-west10">europe-west10</button> <button value="europe-west12">europe-west12</button> <button value="europe-west15">europe-west15</button> <button value="europe-west2">europe-west2</button> <button value="europe-west3">europe-west3</button> <button value="europe-west4">europe-west4</button> <button value="europe-west6">europe-west6</button> <button value="europe-west8">europe-west8</button> <button value="europe-west9">europe-west9</button> <button value="me-central1">me-central1</button> <button value="me-central2">me-central2</button> <button value="me-west1">me-west1</button> <button value="northamerica-northeast1">northamerica-northeast1</button> <button value="northamerica-northeast2">northamerica-northeast2</button> <button value="northamerica-south1">northamerica-south1</button> <button value="southamerica-east1">southamerica-east1</button> <button value="southamerica-west1">southamerica-west1</button> <button value="us-central1">us-central1</button> <button value="us-east1">us-east1</button> <button value="us-east4">us-east4</button> <button value="us-east5">us-east5</button> <button value="us-east7">us-east7</button> <button value="us-south1">us-south1</button> <button value="us-west1">us-west1</button> <button value="us-west2">us-west2</button> <button value="us-west3">us-west3</button> <button value="us-west4">us-west4</button>   
`POST https://datastream.googleapis.com/v1/{parent}/connectionProfiles:discover`

<br />

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. The parent resource of the connection profile type. Must be in the format `projects/*/locations/*`. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `parent`: - `datastream.connectionProfiles.discover` |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { // Union field `target` can be only one of the following: "connectionProfile": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.connectionProfiles#ConnectionProfile`) }, "connectionProfileName": string // End of list of possible types for union field `target`. // Union field `hierarchy` can be only one of the following: "fullHierarchy": boolean, "hierarchyDepth": integer // End of list of possible types for union field `hierarchy`. // Union field `data_object` can be only one of the following: "oracleRdbms": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#OracleRdbms`) }, "mysqlRdbms": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#MysqlRdbms`) }, "postgresqlRdbms": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#PostgresqlRdbms`) }, "sqlServerRdbms": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SqlServerRdbms`) }, "salesforceOrg": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SalesforceOrg`) }, "mongodbCluster": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#MongodbCluster`) }, "spannerDatabase": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SpannerDatabase`) }, "sourceCatalog": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SourceCatalog`) } // End of list of possible types for union field `data_object`. } ``` |

| Fields ||
|---|---|
| Union field `target`. The connection profile on which to run discover. `target` can be only one of the following: ||
| `connectionProfile` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.connectionProfiles#ConnectionProfile`)`` Optional. An ad-hoc connection profile configuration. |
| `connectionProfileName` | `string` Optional. A reference to an existing connection profile. |
| Union field `hierarchy`. The depth of the retrieved hierarchy of data objects. `hierarchy` can be only one of the following: ||
| `fullHierarchy` | `boolean` Optional. Whether to retrieve the full hierarchy of data objects (TRUE) or only the current level (FALSE). |
| `hierarchyDepth` | `integer` Optional. The number of hierarchy levels below the current level to be retrieved. |
| Union field `data_object`. The data object to populate with child data objects and metadata. `data_object` can be only one of the following: ||
| `oracleRdbms` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#OracleRdbms`)`` Optional. Oracle RDBMS to enrich with child data objects and metadata. |
| `mysqlRdbms` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#MysqlRdbms`)`` Optional. MySQL RDBMS to enrich with child data objects and metadata. |
| `postgresqlRdbms` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#PostgresqlRdbms`)`` Optional. PostgreSQL RDBMS to enrich with child data objects and metadata. |
| `sqlServerRdbms` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SqlServerRdbms`)`` Optional. SQLServer RDBMS to enrich with child data objects and metadata. |
| `salesforceOrg` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SalesforceOrg`)`` Optional. Salesforce organization to enrich with child data objects and metadata. |
| `mongodbCluster` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#MongodbCluster`)`` Optional. MongoDB cluster to enrich with child data objects and metadata. |
| `spannerDatabase` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SpannerDatabase`)`` Optional. Spanner database to enrich with child data objects and metadata. |
| `sourceCatalog` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SourceCatalog`)`` Optional. Source catalog to enrich with child data objects and metadata. This is mainly used to represent SaaS sources databases. |

### Response body

Response from a discover request.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { // Union field `data_object` can be only one of the following: "oracleRdbms": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#OracleRdbms`) }, "mysqlRdbms": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#MysqlRdbms`) }, "postgresqlRdbms": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#PostgresqlRdbms`) }, "sqlServerRdbms": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SqlServerRdbms`) }, "salesforceOrg": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SalesforceOrg`) }, "mongodbCluster": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#MongodbCluster`) }, "spannerDatabase": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SpannerDatabase`) }, "sourceCatalog": { object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SourceCatalog`) } // End of list of possible types for union field `data_object`. } ``` |

| Fields ||
|---|---|
| Union field `data_object`. The data object that has been enriched by the discover API call. `data_object` can be only one of the following: ||
| `oracleRdbms` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#OracleRdbms`)`` Enriched Oracle RDBMS object. |
| `mysqlRdbms` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#MysqlRdbms`)`` Enriched MySQL RDBMS object. |
| `postgresqlRdbms` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#PostgresqlRdbms`)`` Enriched PostgreSQL RDBMS object. |
| `sqlServerRdbms` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SqlServerRdbms`)`` Enriched SQLServer RDBMS object. |
| `salesforceOrg` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SalesforceOrg`)`` Enriched Salesforce organization. |
| `mongodbCluster` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#MongodbCluster`)`` Enriched MongoDB cluster. |
| `spannerDatabase` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SpannerDatabase`)`` Enriched Spanner database. |
| `sourceCatalog` | ``object (`https://docs.cloud.google.com/datastream/docs/reference/rest/v1/projects.locations.streams#SourceCatalog`)`` Enriched source catalog. This is mainly used to represent SaaS sources databases. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `https://www.googleapis.com/auth/cloud-datastream
  `

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

### IAM Permissions

Requires the following [IAM](https://cloud.google.com/iam/docs) permission on the `parent` resource:

- `datastream.connectionProfiles.discover`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).